diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
index 7b257cfa7..c2b441e6a 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
@@ -5,37 +5,40 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkLoaderLegacy;
 import net.minecraft.core.world.chunk.EmptyChunk;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.chunk.reader.*;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
+import net.minecraft.core.world.save.LevelStorageDummy;
 import net.minecraft.core.world.save.mcregion.RegionFileCache;
-import net.minecraft.core.world.type.WorldTypes;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
+import org.useless.seedviewer.bta.DummyWorld;
 
 import java.io.DataInputStream;
 import java.io.File;
 import java.io.IOException;
+import java.lang.reflect.Field;
 import java.util.Arrays;
 
-public class ChunkLoader implements IChunkProvider {
+public class ChunkLoader implements ChunkProvider {
     private static final Logger LOGGER = LogUtils.getLogger();
     private final @NotNull World dummyWorld;
     private final @NotNull Chunk empty;
 
 
     private final File dimensionDir;
-    public ChunkLoader(File worldFolder, int dimension) {
-        this.dimensionDir = new File(worldFolder, "dimensions/" + dimension);
-        this.dummyWorld = new World();
-        this.dummyWorld.worldType = WorldTypes.OVERWORLD_EXTENDED;
-        this.dummyWorld.chunkProvider = this;
+    public ChunkLoader(File worldFolder, Dimension dimension) {
+        this.dimensionDir = new File(worldFolder, "dimensions/" + dimension.id);
+        DummyWorld.CHUNK_LOADER = this;
+        this.dummyWorld = new DummyWorld(dimension);
         this.empty = new EmptyChunk(this.dummyWorld, 0, 0);
     }
 
@@ -58,8 +61,8 @@ public class ChunkLoader implements IChunkProvider {
         return tag.containsKey("Level");
     }
 
-    public Chunk loadChunk(ChunkPos location) throws IOException {
-        DataInputStream regionStream = RegionFileCache.getChunkInputStream(this.dimensionDir, location.x, location.z);
+    public @Nullable Chunk loadChunk(ChunkPosc location) throws IOException {
+        DataInputStream regionStream = RegionFileCache.getChunkInputStream(this.dimensionDir, location.x(), location.z());
         CompoundTag tag;
         if(regionStream != null)
         {
@@ -71,7 +74,7 @@ public class ChunkLoader implements IChunkProvider {
         }
         if(!tag.containsKey("Level"))
         {
-            LOGGER.error("Chunk file at {},{} is missing level data, skipping", location.x, location.z);
+            LOGGER.error("Chunk file at {},{} is missing level data, skipping", location.x(), location.z());
             return null;
         }
         return loadChunkFromCompound(tag.getCompound("Level"));
@@ -130,12 +133,12 @@ public class ChunkLoader implements IChunkProvider {
     }
 
     @Override
-    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
         return false;
     }
 
     @Override
-    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         try {
             return loadChunk(chunkPos);
         } catch (IOException e) {
@@ -144,17 +147,17 @@ public class ChunkLoader implements IChunkProvider {
     }
 
     @Override
-    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         return provideChunk(chunkPos, true);
     }
 
     @Override
-    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
 
     }
 
     @Override
-    public void populate(@NotNull ChunkPos chunkPos) {
+    public void populate(@NotNull ChunkPosc chunkPos) {
 
     }
 
@@ -184,7 +187,7 @@ public class ChunkLoader implements IChunkProvider {
     }
 
     @Override
-    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
 
     }
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java
index cc8069d74..e3d1e1cf7 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java
@@ -3,6 +3,7 @@ package org.useless.seedviewer.bta.worldloader;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.save.DimensionData;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -15,22 +16,22 @@ import java.util.Objects;
 public class DimensionDataLoader {
     private static final Logger LOGGER = LogUtils.getLogger();
     @Nullable
-    public static DimensionData getDimensionData(@NotNull File worldDir, int dimensionId) {
+    public static DimensionData getDimensionData(@NotNull File worldDir, @NotNull Dimension dimension) {
         Objects.requireNonNull(worldDir, "WorldDir must not be null!");
-        CompoundTag tag = getDimensionDataRaw(worldDir, dimensionId);
+        CompoundTag tag = getDimensionDataRaw(worldDir, dimension);
         if (tag == null) return null;
-        return new DimensionData(tag);
+        return DimensionData.fromCompoundTag(tag, dimension);
     }
 
     @Nullable
-    public static CompoundTag getDimensionDataRaw(@NotNull File worldDir, int dimensionId)
+    public static CompoundTag getDimensionDataRaw(@NotNull File worldDir, @NotNull Dimension dimension)
     {
         if(!worldDir.exists())
         {
             return null;
         }
         File dimensionsDir = new File(worldDir, "dimensions");
-        File dimensionDir = new File(dimensionsDir, "" + dimensionId);
+        File dimensionDir = new File(dimensionsDir, "" + dimension.id);
         File dimensionDat = new File(dimensionDir, "dimension.dat");
         if (dimensionDat.exists())
         {
@@ -41,7 +42,7 @@ public class DimensionDataLoader {
             }
             catch (Exception ex)
             {
-                LOGGER.error("Error parsing 'dimension.dat' in '{}' dimension {}", worldDir, dimensionId, ex);
+                LOGGER.error("Error parsing 'dimension.dat' in '{}' dimension {}", worldDir, dimension, ex);
             }
         }
         dimensionDat = new File(dimensionDir, "dimension.dat_old");
@@ -54,7 +55,7 @@ public class DimensionDataLoader {
             }
             catch (Exception ex)
             {
-                LOGGER.error("Error parsing 'dimension.dat_old' in '{}' dimension {}", worldDir, dimensionId, ex);
+                LOGGER.error("Error parsing 'dimension.dat_old' in '{}' dimension {}", worldDir, dimension, ex);
             }
         }
 
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
index a80c5f5c5..3a7d15cff 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
@@ -21,7 +21,7 @@ public class LevelDataLoader {
         Objects.requireNonNull(worldDir, "WorldDir must not be null!");
         CompoundTag tag = getLevelDataRaw(worldDir);
         if (tag == null) return null;
-        return new LevelData(tag);
+        return LevelData.fromCompoundTag(tag);
     }
 
     @Nullable
